#include <allegro.h>



#define f(a,b) for (a = 0; a < b; a++)



// The actual field data
int $field[25],
// The play field colors
//    cfield[x][0..15]: cell colors
$cfield[25][16],
// The pieces and it's rotations.
//    I...O...Z...S...J...L...T...
$pieces[] = {0xF0,0x2222,0xF00,0x4444,0x660,0x660,0x660,0x660,0xC60,0x4C8,0xC60,0x4C8,0x360,
0x462,0x360,0x462,0x470,0x226,0x71,0x322,0x170,0x622,0x74,0x223,0x270,0x262,0x72,0x232},
$colors[] = {0xDFFF, 0xF0F0A0, 0xFF8080, 0xDF00, 0xA0FF, 0xFFD500, 0xEFA0FF},
// Misc. variables
$i, $j, $x, $y, $current_piece, $piece_active, $next_piece, $contact_time, $falling_rate, 
$contact_limit, $fall_speed_counter, $move_rate, $rate_limit, $rotate_pressed, $score, 
$can_move, $total_lines, $lines, $px, $ppiece, $game_over, $current_level, $current_rate, 
$x1, $y1, $x2, $y2, $mask[4], 
// Cell drawing variables
$cell_offset = 16, $cell_size = 13, $cell_bevel = 4;

BITMAP *$offscreen;



// Updates the play field
//      This function clears complete lines and updates the score and total lines counter
//////////////////////////////////////////////////////////////////////////////////////////
$update_field() {
    $lines = 0;
// Clear complete lines
    //for ($i = 0; $i < 25; $i++) {
    f($i, 25) {
		if ($field[$i] == 0xFFFF) {
        // Draw a white line directly to the screen as complete line effect
			$x1 = 32;
            $y1 = $cell_offset * $i;
            $x2 = 192;
            $y2 = $cell_offset * $i + $cell_size;
			$draw_rectangle(screen, -1);
        // Increase the number of lines completed with the current piece
			$lines++;
        // Move down all remaining lines
			//for ($j = 0; $j < $i; $j++) {
            f($j, $i) {
				$field[$i - $j] = $field[$i - $j - 1];
				memcpy($cfield[$i - $j], $cfield[$i - $j - 1], sizeof(int) * 16);
			}
		}
	}
// Add a slight pause for the complete line effect
//      As the effect is drawn directly to the screen, the player will actually see the updated field
//      until the next drawing cycle
    if ($lines) rest(100);
    

    $current_level = $total_lines / 10 + 1;                                 // Update the current level
    $current_rate = $current_rate < 2 ? 2 : 48 - $current_level * 2;     // Update the falling speed

	$score += pow($lines, 2) * 1024 * $current_level;                       // Update the score
	$total_lines += $lines;                                                 // and the lines counter
}



// Draws a rectangle
//      This function is just a shortcut to rectfill()
///////////////////////////////////////////////////////
$draw_rectangle($target, $color) {
    rectfill($target, $x1, $y1, $x2, $y2, $color);
}



// Draws a single cell
//      $y:     the field row for the cell
//      $j:     the field column for the cell
//      $c:     the color for the cell
/////////////////////////////////////////////////////////////////
$draw_cell($y, $j, $c) {
// Calculate some repeating values
    $x1 = 240 - $j * $cell_offset;
    $y1 = $y * $cell_offset;
    $x2 = $x1 + $cell_size;
    $y2 = $y1 + $cell_size;
    
// Draw a big rectangle
    $draw_rectangle($offscreen, $c);
// Draw a small rectangle with a slightly different color
    $x1 += $cell_bevel;
    $y1 += $cell_bevel;
    $draw_rectangle($offscreen, $c << 1);
}



// Use color 0xFF for the next piece preview
/////////////////////////////////////////////
/* $draw_cell2($y, $j, $c) {
// Calculate some repeating values
    int $x1 = 240 - $j * $cell_offset, 
        $y1 = $y * $cell_offset, 
        $x2 = $x1 + $cell_size, 
        $y2 = $y1 + $cell_size,
        r, g, b;
    float h, s, v;
    
// Draw a big rectangle
    $draw_rectangle($offscreen, $x1, $y1, $x2, $y2, $c);
// Draw a small rectangle with a slightly different color
    r = getr($c); g = getg($c); b = getb($c);
    rgb_to_hsv(r, g, b, &h, &s, &v);
    v -= v / 4;
    hsv_to_rgb(h, s, v, &r, &g, &b);
    $draw_rectangle($offscreen, $x1 + $cell_bevel, $y1 + $cell_bevel, $x2, $y2, makecol(r, g, b));
} */



/*
$draw_cell3($y, $j, $c) {
// Calculate some repeating values
    int $x1 = 240 - $j * $cell_offset, 
        $y1 = $y * $cell_offset, 
        $x2 = $x1 + $cell_size, 
        $y2 = $y1 + $cell_size;
    
// Draw a big rectangle
    rect($offscreen, $x1, $y1, $x2, $y2, $c);
// Draw a small rectangle with a slightly different color
    rect($offscreen, $x1 + $cell_bevel, $y1 + $cell_bevel, $x2, $y2, $c << 1);
}
*/



// Sets a piece mask in the mask[] array
//      $piece:     the piece to set into mask[]
//      $offset:    the offset for the mask
/////////////////////////////////////////////////////////////////////////////
$piece_mask($piece, $offset) {
// Get the bit masks from the pieces[] array and place them in the mask[] array
    f($i, 4)
        $mask[$i] = (($pieces[$piece] >> $i * 4) & 0xF) << $offset;
}



// Checks if a piece can fit safely in the play field
//      This function checks if the piece configuration currently in mask[] can be placed
//      on the play field
//      $y:         the y position of the piece on the field
//      Returns:    1 if the piece can be placed, 0 if not
//////////////////////////////////////////////////////////////////////////////////////////
$piece_can_move($y) {
    $can_move = 1;
    //for ($i = 0; $i < 4; $i++)
    f($i, 4)
        $can_move = $can_move && !($field[$y + $i] & $mask[$i]);
    return $can_move;
}



// Adds or removes a piece from the play field
//      This function adds or removes a piece from the field by XORing the piece mask.
//      It also adds the piece to the color field by setting the piece cells' color.
//      The formula used for the color was randomly chosen to provide an acceptable 
//      combination of colors. Some formulas producing acceptable results are:
//          0xFFF4D4 * ($current_piece / 4 + 1)
//          0xFFFFD4 * ($current_piece / 4 + 1)
//          0x1FFFD4 * ($current_piece / 4 + 1)
///////////////////////////////////////////////////////////////////////////////////////
$piece_set() {
    //for ($i = 0; $i < 4; $i++) {
    f($i, 4) {
        $field[$y + $i] ^= $mask[$i];
        //for ($j = 0; $j < 16; $j++)
        f($j, 16)
            if (($mask[$i] & 1 << $j))
                $cfield[$y + $i][$j] = $colors[$current_piece / 4];
    }
}



// Draws a string of text followed by a single numeric value to the offscreen buffer
//      This function is just a simplified shortcut to textprintf_ex()
//      $x:     the x position of the string
//      $y:     the y position of the string
//      $s:     the format string
//      $d:     the numeric value
/////////////////////////////////////////////////////////////////////////////////////
$draw_text($x, $y, $s, $d) {
    textprintf_ex($offscreen, font, $x, $y, -1, -1, $s, $d);
}



// Numeric constants used:
//      GFX_AUTODETECT_WINDOWED   2
//      KEY_UP                   84
//      KEY_DOWN                 85
//      KEY_LEFT                 82
//      KEY_RIGHT                83
//      KEY_A                     1
//      KEY_S                    19
//      KEY_SPACE                75
//      KEY_ESC                  59
//
// Some field color choices:
//      0xFFA0A0
//      0xFFFFD4
//      0xFFD4
///////////////////////////////////////
main() {
	allegro_init();
	set_color_depth(24);
	set_gfx_mode(2, 256, 400, 0, 0);
    install_keyboard();

	$offscreen = create_bitmap(256, 400);

// Field initialization
	//for ($i = 0; $i < 25; $i++) {
    f($i, 25) {
        //for ($j = 0; $j < 16; $j++)
        f($j, 16)
            $cfield[$i][$j] = 0xF0A0A0;
        $field[$i] = 0xC00F;
    }
    $field[24] = -1;			                                // Field base
    
// Variables initialization
    srand(time(NULL));
    $next_piece = rand() % 28;
    $piece_active = $total_lines = $score = $game_over = 0;

// Game cycle
    while (!key[59]) {
        while (retrace_count > 0 && !$game_over) {
        // Get a new piece if there's none at play
            if (!$piece_active) {
                $current_piece = $next_piece;                   // Assign the preview piece
                $next_piece = rand() % 28;                      // Get the new preview piece
                $piece_active = 1;                              // Set the piece at play
                $x = 7; $y = 0;                                 // Starting position
                $piece_mask($current_piece, $x);                // Put the piece mask in the mask[] array
                $piece_set();                                   // Place the piece on the field
            }
            
            $px = $x;                                           // Set temporary variables for position
            $ppiece = $current_piece;                           // and piece rotation
            $falling_rate = $current_rate;                      // Reset falling speed
            $contact_limit = 32;                                // Reset snap time counter
            
        // Input handling
        // Left or Right movement
            $i = key[83];                                       // Prepare repeating value
            if ($i || key[82]) {
                if ($move_rate++ > $rate_limit) {               // If the move counter reaches the current move rate limit
                    $move_rate = 0;                             // reset the move counter
                    $px += $i ? -1 : 1;                      // and move the piece
                    $rate_limit = $rate_limit / 2 + 1;          // Halve the limit to reduce moving time
                }
            }
            else {
                $rate_limit = 32;                               // Reset the move rate limit
                $move_rate = 31;                                // and the move rate counter
            }

        // Rotate Left or Rotate Right
            $i = key[1];                                        // Prepare repeating values  
            $j = key[19];
            if ($j || $i) {
                if (!$rotate_pressed) {                         // Rotate the piece Left or Right
                    if ($i && $ppiece % 4 == 0) $ppiece += 4;
                    $ppiece += $i ? -1: 1;
                    if ($j && $ppiece % 4 == 0) $ppiece -= 4;
                    $rotate_pressed = 1;                        // Make sure the piece rotates just once
                }
            }
            else $rotate_pressed = 0;                           // Piece can be rotated again
            
        // Down movement (soft drop)
            if (key[85]) {
                $falling_rate = $contact_limit = 1;             // Fastest falling speed
                $score++;                                       // Increase the score
            }
            
        // Logic
            $piece_set();                                       // Remove the piece from the field
            
        // Basic wall kick
            $piece_mask($ppiece, $px);
            $can_move = 0;
            //for ($i = 0; $i < 4; $i++)
            f($i, 4)
                $can_move |= $field[$y + $i] & $mask[$i];
            if ($can_move & 0x8000) $px--;
            if ($can_move & 0x4000) $px--;
            if ($can_move & 0x8) $px++;
            if ($can_move & 0x4) $px++;

        // Check X movement
            $piece_mask($ppiece, $px);                          // Get temporary piece mask
            if ($piece_can_move($y)) {                          // If the piece can be placed on the field
                $x = $px;                                       // Update the piece's x position
                $current_piece = $ppiece;                       // and rotation
            }
        // Check Y movement
            $piece_mask($current_piece, $x);                    // Get the updated piece mask
            if ($piece_can_move($y + 1)) {                      // If the move can move down on the field
                $contact_time = 0;
                if (++$fall_speed_counter > $falling_rate) {
                    $y++;                                       // Move the piece down
                    $fall_speed_counter = 0;
                }
            }
            else {                                              // If the piece cannot move down
                $contact_time++;                                // Start the snap countdown
                $fall_speed_counter = 0;
            }
            
            if ($contact_time > $contact_limit) {               // If the snap countdown reaches the snap limit
                $piece_active = 0;                              // the piece snaps on the field simply by deactivating it
                if ($y == 0)                                    // If the piece snaps at the top of the field
                    $game_over = 1;                             // the game is over
            }
        // Remove completed lines
            $update_field();
            $piece_set();                                       // Place the piece on the field at it's new position
            retrace_count--;
        }

    // Redraw the field
        clear_to_color($offscreen, 0x5F);
        //for ($i = 0; $i < 25; $i++) {
        f($i, 25) {
            //for ($j = 0; $j < 16; $j++)
            f($j, 16)
                if ($field[$i] & 1 << $j)
                    $draw_cell($i, $j, $cfield[$i][$j]);
        }
    // Draw the preview piece
        //for ($i = 0; $i < 16; $i++)
        f($i, 16)
            if ($pieces[$next_piece] & 1 << $i)
                $draw_cell($i / 4 + 2, $i % 4, 0x5F);

        $draw_text(32, 0, "Score: %13d", $score);
        $draw_text(32, 10, "Lines: %13d", $total_lines);
        if ($game_over)
            $draw_text(82, 200, "GAME OVER", 0);
        blit($offscreen, screen, 0, 0, 0, 0, 256, 400);
        rest(15);
    }
}
END_OF_MAIN()
